/*********************
LCD显示字符串函数
参数：x-列坐标(0-127), y-行坐标(0-7), str-字符串
*********************/
void LCD_ShowStr(u8 x, u8 y, u8 *str) {
    u8 page = y / 8;    // 计算页地址
    u8 col = x % 64;    // 列地址(每半屏64列)
    
    // 选择左/右半屏
    if(x < 64) {
        LCD_CS1 = 0;
        LCD_CS2 = 1;
    } else {
        LCD_CS1 = 1;
        LCD_CS2 = 0;
        col = x - 64;   // 右半屏列地址
    }
    
    // 设置地址
    LCD_WriteCmd(0xB8 | page); // 页地址
    LCD_WriteCmd(0x40 | col);  // 列地址
    
    // 写入字符串数据
    while(*str) {
        LCD_WriteData(*str++);
    }
}