// 新增全局变量
float Aol = 0;
float PSRR = 0;
float VoMax = 0;

/*********************
主函数修改
*********************/
void main()
{
    // ...（原有初始化代码不变）
    
    while(1)
    {
        if(P70 == 0)
        {
            // ...（原有消抖代码不变）
            
            MeasureVos();  // 状态1
            MeasureIB();   // 状态2
            MeasureAol();   // 新增状态3
            MeasurePSRR();  // 新增状态4
            MeasureVoMax(); // 新增状态5
            DisplayResults();
            
            // ...（原有代码不变）
        }
    }
}

/*********************
新增状态3：测量开环增益Aol
*********************/
void MeasureAol()
{
    float vo1_aol, vo1_aol_prime;
    
    // 第一次测量：K9,10,13,14闭合（P4.0,1,4,5）
    RelayControl(0x33); // 00110011
    Delay1ms(1000);     // 稳定时间
    ADS1115_Write(0x01, 0xD283); // 读取AIN1
    vo1_aol = (float)ADS1115_Read(0x00) * 4.096 / 32768.0;
    
    // 第二次测量：K9,10,13,14,15,16闭合（添加P4.6,7）
    RelayControl(0xF3); // 11110011
    Delay1ms(1000);
    ADS1115_Write(0x01, 0xD283);
    vo1_aol_prime = (float)ADS1115_Read(0x00) * 4.096 / 32768.0;
    
    // 计算Aol（避免除零错误）
    if(fabs(vo1_aol_prime - vo1_aol) > 0.001) {
        Aol = 501.0 * 12.0 / (vo1_aol_prime - vo1_aol);
    } else {
        Aol = 0;
    }
    
    RelayControl(0x00); // 断开所有
}

/*********************
新增状态4：测量PSRR
*********************/
void MeasurePSRR()
{
    float vo1_psrr, vo1_psrr_prime;
    
    // 第一次测量：K9,10,13,14闭合（同状态3首次）
    RelayControl(0x33);
    Delay1ms(1000);
    ADS1115_Write(0x01, 0xD283);
    vo1_psrr = (float)ADS1115_Read(0x00) * 4.096 / 32768.0;
    
    // 第二次测量：K9,10,11,12,13,14闭合（添加P4.2,3）
    RelayControl(0x3F); // 00111111
    Delay1ms(1000);
    ADS1115_Write(0x01, 0xD283);
    vo1_psrr_prime = (float)ADS1115_Read(0x00) * 4.096 / 32768.0;
    
    // 计算PSRR（12-5=7V变化量）
    PSRR = (1.0/501.0) * (vo1_psrr - vo1_psrr_prime) / (2.0 * 7.0);
    
    RelayControl(0x00);
}

/*********************
新增状态5：测量VoMax
*********************/
void MeasureVoMax()
{
    // 闭合K9,10,13,14,15,16（同状态3第二次）
    RelayControl(0xF3);
    Delay1ms(1000);
    
    // 读取AIN3（Vo2）
    ADS1115_Write(0x01, 0xE283); // 配置AIN3单端
    VoMax = (float)ADS1115_Read(0x00) * 4.096 / 32768.0;
    
    RelayControl(0x00);
}

/*********************
修改显示函数
*********************/
void DisplayResults()
{
    char buf[32];
    
    // 原有显示内容...
    sprintf(buf, "Vos:%.2f uV", Vos*1e6);
    LCD_ShowStr(0, 0, buf);
    
    sprintf(buf, "IB:%.1f pA", IB*1e12);
    LCD_ShowStr(0, 1, buf);
    
    // 新增显示内容
    sprintf(buf, "Aol:%.1f dB", 20*log10(fabs(Aol))); // 转换为分贝
    LCD_ShowStr(0, 2, buf);
    
    sprintf(buf, "PSRR:%.1f dB", 20*log10(fabs(PSRR)));
    LCD_ShowStr(0, 3, buf);
    
    sprintf(buf, "VoMax:%.3f V", VoMax);
    LCD_ShowStr(0, 4, buf);
    
    // 电压值显示在屏幕下半部分
    sprintf(buf, "Vo1:%.3f", Vo1);
    LCD_ShowStr(64, 0, buf); // 右半屏起始地址64
    sprintf(buf, "Vo1':%.3f", Vo1_prime);
    LCD_ShowStr(64, 1, buf);
    sprintf(buf, "Vo2:%.3f", VoMax);
    LCD_ShowStr(64, 2, buf);
}