// ...（保持之前的头文件、宏定义和全局变量不变）

/*********************
修改后的显示函数
*********************/
void DisplayResults()
{
    char buf[32];
    
    // 第一列显示主要参数
    // Vos显示为mV，保留3位小数
    sprintf(buf, "Vos:%7.3fmV", Vos*1000);
    LCD_ShowStr(0, 0, buf);
    
    // IB显示为nA，保留2位小数
    sprintf(buf, "IB:%8.2fnA", IB*1e9);
    LCD_ShowStr(0, 1, buf);
    
    // Aol显示为dB，保留1位小数
    sprintf(buf, "Aol:%7.1fdB", 20*log10(fabs(Aol)));
    LCD_ShowStr(0, 2, buf);
    
    // PSRR显示为dB，保留1位小数
    sprintf(buf, "PSRR:%6.1fdB", 20*log10(fabs(PSRR)));
    LCD_ShowStr(0, 3, buf);
    
    // VoMax显示为V，保留3位小数
    sprintf(buf, "VoMax:%6.3fV", VoMax);
    LCD_ShowStr(0, 4, buf);
    
    // 第二列显示原始电压（右半屏）
    // 调整X坐标为64（假设12864屏分左右半屏）
    sprintf(buf, "Vo1:%6.3fV", Vo1);
    LCD_ShowStr(64, 0, buf);
    
    sprintf(buf, "Vo1':%5.3fV", Vo1_prime);
    LCD_ShowStr(64, 1, buf);
    
    sprintf(buf, "Vo2:%6.3fV", VoMax);
    LCD_ShowStr(64, 2, buf);
}

/*********************
需要微调的计算部分
*********************/
void MeasureIB()
{
    // ...保持原有测量代码不变...
    
    // 修改计算公式确保单位正确（原计算正确性不变）
    IB = (Vo1_prime - Vo1) / (2 * 50000.0 * 501.0); // 结果单位是安培
}

void MeasureAol()
{
    // ...保持原有测量代码不变...
    
    // 计算保持原有公式（结果是无量纲倍数）
    if(fabs(vo1_aol_prime - vo1_aol) > 0.001) {
        Aol = 501.0 * 12.0 / (vo1_aol_prime - vo1_aol);
    }
}

void MeasurePSRR()
{
    // ...保持原有测量代码不变...
    
    // 计算结果单位是V/V（无量纲）
    PSRR = (1.0/501.0) * (vo1_psrr - vo1_psrr_prime) / (2.0 * 7.0);
}